<script setup lang="ts">
    import { ref, watch } from 'vue'
    import { Message } from '@/shared/administration/entities/messages/Message'
    import { MessageApi } from '@/shared/administration/entities/messages/MessageApi'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { useUserStore } from '@/shared/user/stores/UserStore'

    const msal = useMsal()
    const userStore = useUserStore(msal)
    const messages = ref<Message[] | undefined>(undefined)
    const messageApi = new MessageApi(msal)

    watch(
        [() => msal.accounts, () => userStore.isImpersonating],
        () => {
            messageApi.getAll().then(
                (returnedMessages) =>
                    (messages.value = returnedMessages.filter((message) => {
                        const currentDate = new Date()
                        const yesterday = new Date(
                            Date.now() - 1 * 24 * 60 * 60 * 1000
                        )

                        if (!message.startDate && !message.endDate) {
                            return true
                        }

                        if (message.startDate && !message.endDate) {
                            return new Date(message.startDate) <= currentDate
                        }

                        if (!message.startDate && message.endDate) {
                            return yesterday <= new Date(message.endDate)
                        }

                        if (message.startDate && message.endDate) {
                            return (
                                new Date(message.startDate) <= currentDate &&
                                yesterday <= new Date(message.endDate)
                            )
                        }

                        return false
                    }))
            )
        },
        { immediate: true }
    )

    function removeAllTagsExceptb(body: string | undefined) {
        if (body) {
            return body.replace(/<(?!\/?b\b)[^>]*>/g, '')
        }
    }
</script>

<template>
    <v-list>
        <v-list-item v-for="message in messages" :key="message.id">
            <v-alert
                :title="message.title"
                :type="message.color"
                data-cy="alert-message"
            >
                <!-- eslint-disable vue/no-v-html -->
                <p
                    style="white-space: pre-wrap"
                    v-html="removeAllTagsExceptb(message.body)"
                ></p>
            </v-alert>
        </v-list-item>
    </v-list>
</template>
